-- Silencer Checks
Hooks:PreHook( SentryGunWeapon, "init", "OldBriefcaseSentry_SilencerCheck", function( self, unit )
	self._silenced = ( self._muzzle_flash_parent == "g_supp" )
end)

-- Silencer Add Hook
Hooks:PostHook( SentryGunWeapon, "init", "OldBriefcaseSentry_SilencerAdd", function( self, unit )
	if self._silenced then
		self:add_barrel_extension( "units/payday2/equipment/gen_equipment_sentry/gen_equipment_sentry_silencer" )
	end

	-- Fix effect align.
	local effect_align = self._unit:get_object(Idstring("fire"))
	if self._barrel_extension then
		effect_align = self._barrel_extension:get_object(Idstring("fire")) or self._unit:get_object(Idstring("fire"))
	end

	self._effect_align = {
		effect_align,
		effect_align
	}
end)

-- Add Barrel Extensions to the Sentry.
function SentryGunWeapon:add_barrel_extension( unit_name )
	local ids_unit_name = Idstring(unit_name)

	-- Load Barrel Extension into memory.
	managers.dyn_resource:load(Idstring("unit"), ids_unit_name, "packages/dyn_resources", false)

	-- Spawn and Link Barrel Extension.
	local unit = World:spawn_unit(ids_unit_name, Vector3(), Rotation())
	local res = self._unit:link(Idstring("fire"), unit, unit:orientation_object():name())

	-- Store it for future reference.
	self._barrel_extension = unit
end

-- Remove Barrel Extensions from the Sentry.
function SentryGunWeapon:remove_barrel_extension()
	if self._barrel_extension then
		self._barrel_extension:set_slot(0)
		self._barrel_extension = nil
	end
end

-- Access the Barrel Extension.
function SentryGunWeapon:barrel_extension()
	return self._barrel_extension
end